天天看點

hdu 3486 Interviewe(二分+rmq)Interviewe

Interviewe

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 5827    Accepted Submission(s): 1374

Problem Description YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.

YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is

hdu 3486 Interviewe(二分+rmq)Interviewe

, which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.

YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?

Input The input consists of multiple cases.

In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.

The input ends up with two negative numbers, which should not be processed as a case.

Output For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.  

Sample Input

11 300
7 100 7 101 100 100 9 100 100 110 110
-1 -1
        

Sample Output

3

   
    
     Hint
    We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, 
and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.
   
    
        

Source 2010 ACM-ICPC Multi-University Training Contest(5)——Host by BJTU 題目分析:

利用st算法預處理出區間最值,然後二分目前的組數,因為組數越多選的人越多,得到的能力值也就越高,因為每個區間變大,很可能覆寫掉之前的最大值,很可能擴大的區間覆寫掉了之前的最大值,導緻最後結果變小,符合單調性,那麼可以二分

#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cmath>
#define MAX 200007 

using namespace std;

int n,m;
int a[MAX];

int dp[MAX][30];

void makermq ( )
{
    for ( int i = 0 ; i < n ; i++ )
        dp[i][0] = a[i];
    for ( int j = 1 ; (1<<j) <= n ; j++ )
        for ( int i = 0 ; i+(1<<j)-1 < n ; i++ )
            dp[i][j] = max ( dp[i][j-1], dp[i+(1<<(j-1))][j-1] );
}

int rmq ( int s , int v )
{
    int k = (int)(log((v-s+1)*1.0)/log(2.0));
    return max ( dp[s][k] , dp[v-(1<<k)+1][k] );
}

bool check ( int mid )
{
    int len = n/mid;
    int sum = 0;
    for ( int i = 0 ; i+len <= mid*len ; i+= len )
        sum += rmq ( i , i+len-1 );
    return sum > m;
}

int solve ( )
{
    int left = 1 , right = n , mid;
    while ( left != right )
    {
        mid = left + right >> 1;
        if ( check ( mid ) ) right = mid;
        else left = mid+1;
    }
    return left;
}

int main ( )
{
    while ( ~scanf ( "%d%d" , &n , &m ) )
    {
        if ( n<0 && m<0 ) break;
        int total = 0;
        for ( int i = 0 ; i < n ; i++ )
        {
            scanf ( "%d" , &a[i] );
            total += a[i];
        }
        if ( total <= m ) 
        {
            puts ( "-1" );
            continue;
        } 
        makermq();
        printf ( "%d\n" , solve ( ) );
    }
}
           

繼續閱讀